/**
  * Aller (le terrier d'AbulEdu)
  *
  * @warning aucun traitement d'erreur n'est pour l'instant implémenté
  * @see https://redmine.ryxeo.com/projects/leterrier-aller
  * @author 2011 Jean-Louis Frucot <frucot.jeanlouis@free.fr>
  * @see The GNU Public License (GPL)
  */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef ABULEDUPIECE_H
#define ABULEDUPIECE_H

#include <QGraphicsObject>
#include <QPainter>
#include <QCursor>
#include <QGraphicsSceneMouseEvent>

class AbuleduPiece : public QGraphicsObject
{
    Q_OBJECT
public:
    /** Définition d'un type customisé pour les pièces */
    enum { AbuleduPieceType = UserType + 300 };

    int type() const
    {
        // Enable the use of qgraphicsitem_cast with this item.
        return AbuleduPieceType;
    }
    explicit AbuleduPiece(QRectF rect, QGraphicsObject *parent = 0);
    /** Positionne la pièce à l'initiaisation
      * @param pos la position de la pièce sur la scene
      */
    void setPositionOriginale(QPointF pos);
    /** Retourne la position originale de la pièce
      * @return position de la pièce
      */
    QPointF positionOriginale();

    /** Fixe le Pen de contour
      * @param contour le pen de contour taille et couleur
      */
    void setPen(QPen contour);
    /** Fixe la brosse de Fond
      * @param brosseFond la brosse de remplissage du fond
      */
    void setBrush(QBrush brosseFond);

    /** Attribue une image qui sera dessinée sur le fond
      * @param cheminImage le chemin vers le fichier de l'image
      */
    void setImage(QString cheminImage);

private:
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);

    QVariant itemChange(GraphicsItemChange change, const QVariant &value);
    QRectF boundingRect() const;
    QRectF m_rect;
    QPointF m_hotspot;
    QPointF m_positionOriginale;
    QPen m_penContour;
    QBrush m_brosseFond;
    QImage m_image;
signals:

public slots:

private slots:
    void mousePressEvent(QGraphicsSceneMouseEvent *event);
    void mouseMoveEvent(QGraphicsSceneMouseEvent *event);
    void mouseReleaseEvent(QGraphicsSceneMouseEvent *event);
//    void mouseDoubleClickEvent(QGraphicsSceneMouseEvent *event);

signals:

    void pieceDeposee(QString nom, int numCellule);

};

#endif // ABULEDUPIECE_H
