/**
  * Aller (le terrier d'AbulEdu)
  *
  * @warning aucun traitement d'erreur n'est pour l'instant implémenté
  * @see https://redmine.ryxeo.com/projects/leterrier-aller
  * @author 2011 Jean-Louis Frucot <frucot.jeanlouis@free.fr>
  * @see The GNU Public License (GPL)
  */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef ABULEDUTABLEAU_H
#define ABULEDUTABLEAU_H

#include <QGraphicsView>

#include "abuleducellule.h"
#include "abuleduentete.h"
#include "abuledupiece.h"
#include "abuleduscenetableau.h"
#include <QMouseEvent>

class AbuleduTableau : public QGraphicsView
{
    Q_OBJECT
public:

    explicit AbuleduTableau(QPointF position, QWidget *parent = 0);
    void setDimensionsWidget(QSize taille);
    /** Fonction de convenance dessinant un tableau de cellules
      * @return  QMap retournant la liste des pointeurs des cellules avec le numéro de la cellule comme clé
      */
    QMap<int, AbuleduCellule *> dessineTableau(QPointF position, int nbColonnes, int largeurColonne, int nbLignes, int hauteurLigne);
    // NSE
    QMap<int, AbuleduEntete *> dessineEnteteTableau(QPointF position, int nbColonnes, int largeurColonne, int nbLignes, int hauteurLigne);
    QMap<int, AbuleduEntete *> dessineEnteteTableauLigne(QPointF position, int nbColonnes, int largeurColonne, int nbLignes, int hauteurLigne, QString posLigne);
    QMap<int, AbuleduEntete *> dessineEnteteTableauColonne(QPointF position, int nbColonnes, int largeurColonne, int nbLignes, int hauteurLigne, QString posColonne);

private:

    QGraphicsScene *m_scene;
    QPointF m_position;

signals:

public slots:

protected slots:
//    void mousePressEvent(QMouseEvent *event);
//    void mouseReleaseEvent(QMouseEvent *event);

};

#endif // ABULEDUTABLEAU_H
