/**
  * Aller (le terrier d'AbulEdu)
  *
  * @warning aucun traitement d'erreur n'est pour l'instant implémenté
  * @see https://redmine.ryxeo.com/projects/leterrier-aller
  * @author 2011 Jean-Louis Frucot <frucot.jeanlouis@free.fr>
  * @see The GNU Public License (GPL)
  */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QGraphicsItem>
#include <QDebug>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    m_gvTableau = new AbuleduTableau(QPointF(0,0),ui->frame);

    // NSE
    m_nbCol = 5;
    m_nbLigne = 3;
    m_tailleCol = 100;
    m_tailleLigne = 75;

    m_posLigne = "D";
    m_posColonne = "H";

    // old version : listeCellules = m_gvTableau->dessineTableau(QPointF(100, 50),5, 100, 3, 75);
    listeCellules = m_gvTableau->dessineTableau(QPointF(125, 100),m_nbCol, m_tailleCol, m_nbLigne, m_tailleLigne);
    // NSE
    // listeCellulesEntetes = m_gvTableau->dessineEnteteTableau(QPointF(100, 50),5, 100, 3, 75);
    // listeEntetes = m_gvTableau->dessineEnteteTableau(QPointF(125, 100),m_nbCol, m_tailleCol, m_nbLigne, m_tailleLigne);

    // NSE version avec entetes à Gauche/Droite et Haut/Bas
    listeEntetesLigne = m_gvTableau->dessineEnteteTableauLigne(QPointF(125, 100),m_nbCol, m_tailleCol, m_nbLigne, m_tailleLigne, m_posLigne);
    listeEntetesColonne = m_gvTableau->dessineEnteteTableauColonne(QPointF(125, 100),m_nbCol, m_tailleCol, m_nbLigne, m_tailleLigne, m_posColonne);

    // Une pièce vide
    m_piece = new AbuleduPiece(QRectF(0, 0, 100, 50));
    m_piece->setParent(m_gvTableau->scene());
    m_piece->setObjectName("Piece 0");
    m_gvTableau->scene()->addItem(m_piece);
    m_piece->setPen(QColor(Qt::blue));
    // m_piece->setPositionOriginale(QPointF(100, 300));
    m_piece->setPositionOriginale(QPointF(100, 350));
    connect(m_piece, SIGNAL(pieceDeposee(QString,int)),
            this, SLOT(SlotPieceDeposee(QString,int)));

    // Une autre piece avec une tête de Pingoin
    m_piece = new AbuleduPiece(QRectF(0, 0, 100, 50));
    m_piece->setParent(m_gvTableau->scene());
    m_piece->setPen(QPen(Qt::green, 3, Qt::DashDotLine, Qt::RoundCap, Qt::RoundJoin));
    m_piece->setBrush(Qt::yellow);
    m_piece->setImage("teteBien.png");
    m_piece->setObjectName("Piece 1");
    m_gvTableau->scene()->addItem(m_piece);
    // m_piece->setPositionOriginale(QPointF(250, 300));
    m_piece->setPositionOriginale(QPointF(250, 350));
    connect(m_piece, SIGNAL(pieceDeposee(QString,int)),
            this, SLOT(SlotPieceDeposee(QString,int)));

}


MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void MainWindow::resizeEvent(QResizeEvent *)
{
    setDimensionsWidget();
}

void MainWindow::showEvent(QShowEvent *)
{
    setDimensionsWidget();
}

void MainWindow::setDimensionsWidget()
{
    m_gvTableau->setDimensionsWidget(ui->frame->size());
}

void MainWindow::SlotPieceDeposee(QString nom, int numCellule)
{
    qDebug()<<"----------------------------------------------------";
    qDebug()<<"        Je suis la piece :"<<nom<<". Je suis sur la cellule :"<<numCellule+1;
    // qDebug()<<"On peut aussi dire que je suis dans la colonne No"<<numCellule%3+1<<" et dans la ligne"<<numCellule/3+1;
    // NSE
    qDebug()<<"On peut aussi dire que je suis dans la colonne No"<<numCellule%m_nbCol+1<<" et dans la ligne"<<numCellule/m_nbCol+1;
    qDebug()<<"----------------------------------------------------";

}

void MainWindow::on_btnUpdateTableau_clicked()
{

}
