/**
  * Aller (le terrier d'AbulEdu)
  *
  * @warning aucun traitement d'erreur n'est pour l'instant implémenté
  * @see https://redmine.ryxeo.com/projects/leterrier-aller
  * @author 2011 Jean-Louis Frucot <frucot.jeanlouis@free.fr>
  * @see The GNU Public License (GPL)
  */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QDebug>
#include "abuledutableau.h"


namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();


protected:
    void changeEvent(QEvent *e);
    void setDimensionsWidget();
private:
    Ui::MainWindow *ui;
    AbuleduTableau *m_gvTableau;
    QMap<int, AbuleduCellule *>listeCellules;
    QMap<int, AbuleduEntete *>listeEntetes;
    QMap<int, AbuleduEntete *>listeEntetesLigne;
    QMap<int, AbuleduEntete *>listeEntetesColonne;

    AbuleduPiece *m_piece;

    // NSE
    int m_nbCol;
    int m_nbLigne;
    int m_tailleCol;
    int m_tailleLigne;
    QString m_posColonne;
    QString m_posLigne;

private slots:
    void resizeEvent(QResizeEvent *);
    void showEvent(QShowEvent *);
    void SlotPieceDeposee(QString nom, int numCellule);
    void on_btnUpdateTableau_clicked();
};

#endif // MAINWINDOW_H
